/* config.h.  Generated from config.h.in by configure.  */
/* config.h.in.  Generated from configure.ac by autoheader.  */

/********************************************************************
* Description: config.h
*
*	Common defines used in many emc2 source files.
*       To add to this file, edit Section 4 in configure.ac
*       and then run autoheader.
*
* Author: Autogenerated by autoheader
* License: LGPL Version 2
* System: Linux
*
* Copyright (c) 2004 All rights reserved.
********************************************************************/
#ifndef EMC2_CONFIG_H
#define EMC2_CONFIG_H

/* LINELEN is used throughout for buffer sizes, length of file name strings,
   etc. Let's just have one instead of a multitude of defines all the same. */
#define LINELEN 255
/* Used in a number of places for sprintf() buffers. */
#define BUFFERLEN 80

#define MM_PER_INCH 25.4
#define INCH_PER_MM (1.0/25.4)

/* RTAPI array sizes */
#define RTAPI_MAX_MODULES	64
#define RTAPI_MAX_TASKS		64
#define RTAPI_MAX_SHMEMS	32

#define MAX_INSTANCES           16

// default size of the HAL data segment
// can be overridden by the rtapi.so/ko module param hal_size=<n>
#define HAL_SIZE                262000

// minimum memlock limit
// see http://wiki.linuxcnc.org/cgi-bin/wiki.pl?LockedMemory
// edit /etc/security/limits.conf to read:
//  *       -    memlock 20480
#define RLIMIT_MEMLOCK_RECOMMENDED (20480*1024lu)

// default size of the thread stack size passed to rtapi_task_new()
// in hal_create_thread()
// can be overridden by an option to rtapi_msgd
#define HAL_STACKSIZE           32768

// a pseudo-flavor id to indicate ulapi<flavor>.so is not yet loaded
// not a build target, just a state indicator for ulapi_autoload.c
#define RTAPI_NOTLOADED_NAME  "not-yet-loaded"
#define RTAPI_NOTLOADED_ID    99

// format of zeroMQ IPC socket pathnames
// pass: RUNDIR, rtapi_instance, service name, uuid
// service name is: log, rtapi, halrcomp etc
#define ZMQIPC_FORMAT "ipc://%s/%d.%s.%s"


// flavor IDs for the various threads systems
// and conditional to set thread system and build_sys macros
// alter these in configure.ac Subsection 2.0
#define RTAPI_POSIX_ID 0
#define RTAPI_POSIX_NAME "posix"
#define RTAPI_RT_PREEMPT_ID 1
#define RTAPI_RT_PREEMPT_NAME "rt-preempt"
#define RTAPI_XENOMAI_ID 2
#define RTAPI_XENOMAI_NAME "xenomai"
#define RTAPI_XENOMAI_KERNEL_ID 3
#define RTAPI_XENOMAI_KERNEL_NAME "xenomai-kernel"
#define RTAPI_RTAI_KERNEL_ID 4
#define RTAPI_RTAI_KERNEL_NAME "rtai-kernel"

#if ! defined(THREAD_FLAVOR_ID)
// this isn't allowed when building RTAPI
#ifdef RTAPI
#error RTAPI defined but THREAD_FLAVOR_ID not defined
#endif
#elif THREAD_FLAVOR_ID == RTAPI_POSIX_ID
#  define RTAPI_POSIX
#  define THREAD_FLAVOR_NAME "posix"
#  define BUILD_SYS_USER_DSO
#  define THREADS_HEADERS "rtapi/rt-preempt.h"
#elif THREAD_FLAVOR_ID == RTAPI_RT_PREEMPT_ID
#  define RTAPI_RT_PREEMPT
#  define THREAD_FLAVOR_NAME "rt-preempt"
#  define BUILD_SYS_USER_DSO
#  define THREADS_HEADERS "rtapi/rt-preempt.h"
#elif THREAD_FLAVOR_ID == RTAPI_XENOMAI_ID
#  define RTAPI_XENOMAI
#  define THREAD_FLAVOR_NAME "xenomai"
#  define BUILD_SYS_USER_DSO
#  define THREADS_HEADERS "rtapi/xenomai.h"
#elif THREAD_FLAVOR_ID == RTAPI_XENOMAI_KERNEL_ID
#  define RTAPI_XENOMAI_KERNEL
#  define THREAD_FLAVOR_NAME "xenomai-kernel"
#  define BUILD_SYS_KBUILD
#  define THREADS_HEADERS "rtapi/xenomai-kernel.h"
#elif THREAD_FLAVOR_ID == RTAPI_RTAI_KERNEL_ID
#  define RTAPI_RTAI_KERNEL
#  define THREAD_FLAVOR_NAME "rtai-kernel"
#  define BUILD_SYS_KBUILD
#  define THREADS_HEADERS "rtapi/rtai-kernel.h"
#else
#error unknown value for THREAD_FLAVOR_ID
#endif



/* build hardware drivers */
#define BUILD_DRIVERS /**/

/* build emcweb UI */
/* #undef BUILD_EMCWEB */

/* build programming examples */
/* #undef BUILD_EXAMPLES */

/* build NML dependent parts */
/* #undef BUILD_NMLDEP */

/* Directory for binaries */
#define EMC2_BIN_DIR "/usr/bin"

/* Default nml file */
#define EMC2_DEFAULT_NMLFILE "/usr/share/linuxcnc/linuxcnc.nml"

/* Default tooltable file */
#define EMC2_DEFAULT_TOOLTABLE ""

/* Prefix or RIP directory */
#define EMC2_HOME "/usr"

/* Directory for images */
#define EMC2_IMAGE_DIR "/usr/share/linuxcnc"

/* Directory for nc files */
#define EMC2_NCFILES_DIR "/usr/share/linuxcnc/ncfiles"

/* Directory for po/mo translation files */
#define EMC2_PO_DIR "/usr/share/locale"

/* Directory for ulapi shared objects */
#define EMC2_RTLIB_DIR "/usr/lib/linuxcnc"

/* SHA valid when configure was run */
#define GIT_CONFIG_SHA "b44a0ac"

/* Git version tag */
#define GIT_VERSION "v0.2~-detached~b44a0ac"

/* avahi mDNS client library available */
#define HAVE_AVAHI /**/

/* Define to 1 if you have the <backtrace.h> header file. */
#define HAVE_BACKTRACE_H 1

/* define if the Boost library is available */
#define HAVE_BOOST /**/

/* define if the Boost::Python library is available */
#define HAVE_BOOST_PYTHON /**/

/* define if the Boost::Serialization library is available */
/* #undef HAVE_BOOST_SERIALIZATION */

/* define if the Boost::System library is available */
/* #undef HAVE_BOOST_SYSTEM */

/* define if the Boost::Thread library is available */
/* #undef HAVE_BOOST_THREAD */

/* Use concurrencykit */
/* #undef HAVE_CK */

/* Define to 1 if you have the `clock_getres' function. */
#define HAVE_CLOCK_GETRES 1

/* define if the compiler supports basic C++11 syntax */
#define HAVE_CXX11 1

/* zeroMQ czmq library available */
#define HAVE_CZMQ /**/

/* Define to 1 if you have the <GL/glu.h> header file. */
#define HAVE_GL_GLU_H 1

/* Define to 1 if you have the <GL/gl.h> header file. */
#define HAVE_GL_GL_H 1

/* gtk > 2.4 available HAVE_GTK set */
#define HAVE_GTK 1

/* Define to 1 if you have the <inttypes.h> header file. */
#define HAVE_INTTYPES_H 1

/* jansson JSON C bindings available */
#define HAVE_JANSSON /**/

/* libbacktrace available */
#define HAVE_LIBBACKTRACE /**/

/* Define to 1 if you have the <libbacktrace/backtrace.h> header file. */
/* #undef HAVE_LIBBACKTRACE_BACKTRACE_H */

/* libcgroup library available */
#define HAVE_LIBCGROUP /**/

/* Define to 1 if you have the `GL' library (-lGL). */
#define HAVE_LIBGL 1

/* Define to 1 if you have the `intl' library (-lintl). */
/* #undef HAVE_LIBINTL */

/* Define to 1 if you have the <libintl.h> header file. */
#define HAVE_LIBINTL_H 1

/* Define to 1 if you have the `ncurses' library (-lncurses). */
#define HAVE_LIBNCURSES 1

/* libudev installed and available */
#define HAVE_LIBUDEV /**/

/* Define to 1 if you have the `Xaw' library (-lXaw). */
#define HAVE_LIBXAW 1

/* Define to 1 if you have the `Xinerama' library (-lXinerama). */
#define HAVE_LIBXINERAMA 1

/* Define to 1 if you have the <locale.h> header file. */
#define HAVE_LOCALE_H 1

/* if lttng-ust support is available */
/* #undef HAVE_LTTNG_UST */

/* libwebsockets library available */
#define HAVE_LWS /**/

/* Define to 1 if you have the <memory.h> header file. */
#define HAVE_MEMORY_H 1

/* Define to 1 if you have the <ncurses.h> header file. */
#define HAVE_NCURSES_H 1

/* Build POSIX threads */
#define HAVE_POSIX_THREADS /**/

/* protobuf library available */
#define HAVE_PROTOBUF /**/

/* If available, contains the Python version number currently in use. */
#define HAVE_PYTHON "2.7"

/* Define to 1 if you have the 'readline' library (-lreadline) and required
   headers */
#define HAVE_READLINE /**/

/* Define to 1 if you have the <readline/history.h> header file. */
#define HAVE_READLINE_HISTORY_H 1

/* Define to 1 if you have the <readline/readline.h> header file. */
#define HAVE_READLINE_READLINE_H 1

/* Build RTAI threads */
/* #undef HAVE_RTAI_KERNEL_THREADS */

/* Build RT_PREEMPT threads */
#define HAVE_RT_PREEMPT_THREADS /**/

/* Define to 1 if you have the `semtimedop' function. */
#define HAVE_SEMTIMEDOP 1

/* Define to 1 if you have the `setlocale' function. */
#define HAVE_SETLOCALE 1

/* Define to 1 if sincos is available. */
#define HAVE_SINCOS 1

/* libssl library available */
#define HAVE_SSL /**/

/* Define to 1 if you have the <stdint.h> header file. */
#define HAVE_STDINT_H 1

/* Define to 1 if you have the <stdlib.h> header file. */
#define HAVE_STDLIB_H 1

/* Define to 1 if you have the <strings.h> header file. */
#define HAVE_STRINGS_H 1

/* Define to 1 if you have the <string.h> header file. */
#define HAVE_STRING_H 1

/* Define to 1 if you have the <sys/stat.h> header file. */
#define HAVE_SYS_STAT_H 1

/* Define to 1 if you have the <sys/types.h> header file. */
#define HAVE_SYS_TYPES_H 1

/* Define to 1 if you have <sys/wait.h> that is POSIX.1 compatible. */
#define HAVE_SYS_WAIT_H 1

/* Define to 1 if you have the <unistd.h> header file. */
#define HAVE_UNISTD_H 1

/* uriparser library available */
#define HAVE_URIPARSER /**/

/* uuid library available */
#define HAVE_UUID /**/

/* Define to 1 if you have the <X11/extensions/Xinerama.h> header file. */
#define HAVE_X11_EXTENSIONS_XINERAMA_H 1

/* Define to 1 if you have the <X11/Xaw/XawInit.h> header file. */
#define HAVE_X11_XAW_XAWINIT_H 1

/* Define to 1 if you have the <X11/Xmu/Xmu.h> header file. */
#define HAVE_X11_XMU_XMU_H 1

/* Build Xenomai kernel threads */
/* #undef HAVE_XENOMAI_KERNEL_THREADS */

/* Build Xenomai userland threads */
#define HAVE_XENOMAI_THREADS /**/

/* Define to 1 if you have the `__sincos' function. */
/* #undef HAVE___SINCOS */

/* Define to 1 if linux/hidraw.h is usable and defines HIDIOCGRAWINFO */
#define HIDRAW_H_USABLE /**/

/* path of global machinekit.ini file */
#define MACHINEKIT_INI "/etc/linuxcnc/machinekit.ini"

/* Define to 1 if asm/msr.h is usable and defines rdtscll */
/* #undef MSR_H_USABLE */

/* Define to the address where bug reports for this package should be sent. */
#define PACKAGE_BUGREPORT "emc-developers@lists.sourceforge.net"

/* Define to the full name of this package. */
#define PACKAGE_NAME "LinuxCNC"

/* Define to the full name and version of this package. */
#define PACKAGE_STRING "LinuxCNC 0.2"

/* Define to the one symbol short name of this package. */
#define PACKAGE_TARNAME "linuxcnc"

/* Define to the home page for this package. */
#define PACKAGE_URL ""

/* Define to the version of this package. */
#define PACKAGE_VERSION "0.2"

/* "RTAI version" */
/* #undef RTAI_VERSION */

/* directory for IPC sockets and other transient files */
#define RUNDIR "/tmp"

/* Define to 1 if you have the ANSI C header files. */
/* #undef STDC_HEADERS */

/* build for BeagleBone platform */
/* #undef TARGET_PLATFORM_BEAGLEBONE */

/* build for Chip platform */
/* #undef TARGET_PLATFORM_CHIP */

/* build for H3 SoC platform */
/* #undef TARGET_PLATFORM_H3 */

/* build for PC platform */
#define TARGET_PLATFORM_PC /**/

/* build for Raspberry Pi platform */
/* #undef TARGET_PLATFORM_RASPBERRY */

/* build for Socfpga platform */
/* #undef TARGET_PLATFORM_SOCFPGA */

/* build for Zedboard platform */
/* #undef TARGET_PLATFORM_ZEDBOARD */

/* build PCI drivers with usermode PCI support */
#define USERMODE_PCI /**/

/* use ppdev ioctl instead of inb/outb */
/* #undef USE_PORTABLE_PARPORT_IO */

/* use shm driver module */
/* #undef USE_SHMDRV */

/* Xenomai skin ('native' for v2, 'alchemy' for v3) */
#define XENOMAI_SKIN native

/* Xenomai v.2 */
#define XENOMAI_V2 /**/

/* Define to 1 if the X Window System is missing or not being used. */
/* #undef X_DISPLAY_MISSING */

/* Enable GNU extensions on systems that have them.  */
#ifndef _GNU_SOURCE
# define _GNU_SOURCE
#endif


#endif

